﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace SaferPlayer
{
    public partial class SoundPlayer : UserControl
    {
        [DllImport("winmm.dll")]
        private static extern long mciSendString(string strCommand, StringBuilder strReturn, int iReturnLength, IntPtr hwndCallback);
        private string Pcommand;
        private bool isOpen;

        bool fileselected;
        bool _IsPlaying = false;

        public bool FileIsSelected
        {
            get { return fileselected; }
        }

        public bool IsPlaying
        {
            get { return _IsPlaying; }
        }
        

        private string _SoundLocation;

        public string SoundLocation
        {
            get { return _SoundLocation; }
            set
            {
                string exen = Path.GetExtension(value);

                if (exen != ".mp3" && exen != ".wav")
                {
                    fileselected = false;
                    button_play.Enabled = false;
                    label_selectedFile.Text = "Dosya seçilmedi";
                    return;
                }

                if (File.Exists(value))
                {
                    _SoundLocation = value;
                    label_selectedFile.Text = "Dosya: " + Path.GetFileNameWithoutExtension(value);
                    fileselected = true;
                    button_play.Enabled = true;
                }
                else
                {
                    fileselected = false;
                    button_play.Enabled = false;
                    label_selectedFile.Text = "Dosya seçilmedi";
                }
            }
        }
        

        public SoundPlayer()
        {
            InitializeComponent();
        }

        private void button_selectSound_Click(object sender, EventArgs e)
        {
            OpenFileDialog selectFile = new OpenFileDialog();
            selectFile.Filter = "Media File(*.wav,*.mp3)|*.wav;*.mp3";
            DialogResult result = selectFile.ShowDialog();
            if (result == DialogResult.OK)
            {
                SoundLocation = selectFile.FileName;
            }
        }

        private void button_play_Click(object sender, EventArgs e)
        {
            switch (button_play.Text)
            {
                case "Oynat":
                    PlaySound();
                    break;
                case "Durdur":
                    StopSound();
                    break;
            }
        }

        public bool PlaySound()
        {
            if (!FileIsSelected)
            {
                return false;
            }

            button_play.Text = "Durdur";
            button_selectSound.Enabled = false;

            Pcommand = "open \"" + SoundLocation + "\" type mpegvideo alias MediaFile";
            mciSendString(Pcommand, null, 0, IntPtr.Zero);
            isOpen = true;
            Play(true);
            _IsPlaying = true;
            return true;
        }

        void Play(bool loop)
        {
            if (isOpen)
            {
                Pcommand = "play MediaFile";
                if (loop)
                    Pcommand += " REPEAT";
                mciSendString(Pcommand, null, 0, IntPtr.Zero);
            }
        }

        public void StopSound()
        {
            Pcommand = "close MediaFile";
            mciSendString(Pcommand, null, 0, IntPtr.Zero);
            isOpen = false;

            button_play.Text = "Oynat";
            button_selectSound.Enabled = true;
            _IsPlaying = false;
        }
    }
}
